=pod

Module O_N.pm 

A component of the checker group of programs for monitoring applications, databases, networks, 
all types of servers, and more. By Nova Software, Inc. 

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut
  package O_N ; our $VERSION = 0.180321; use strict; use warnings; use sigtrap; use O_B 0.170824; use O_M 0.170824; use O_U 0.170824;
use O_L 0.170824; use O_W 0.170824; use O_D 0.170824; use O_C 0.170824;   use O_A 0.170824;  use O_T 0.170824; use O_P 0.170824; use O_R 0.170824; use JinKey;  use IO::Socket; use Data::Dumper; $| = 1;  my $yyN = '';  sub qcN { jsB(shift);   nbB(shift);  my $jqN =  $_[0] eq acB ? shift : 0 ;   g2U();  my $xlN = qbB.'1';  if (-f $xlN) {
my @tmp = mhU( $xlN ) ; $yyN = join '', @tmp;  } if (not @_ or $_[0] =~/^-[a-z]|^!$|\?/i) {  i8N(@_); exit 0; } my $xjN = cfB."\n".bkB.riB().", r. ".skB().", on ".bhB()."\n" ."Base directory: ".w1B()."\nNova Software, www.nova-sw.com"; my $szN = 0 ;  if (kbB())  {         if ($_[0] and $_[0] eq m2B) {  $szN = shift;  my $jjN = 'startup_'.riB().'.txt' ;  if (open STDOUT, ">$jjN") { print "\n".cfB.' '.riB()."  pid = $$\n" ; open STDERR, ">>$jjN" ;   }  else { wmL cwM( 69, $jjN, $! ) ;
}             } else {  lxN($xjN, $_[0], $szN) ;  ybR();   faN(); oeR();  bxU(skB(), nbB(), m2B, @_) unless $jqN;  } }  else {  ybR();  faN();  oeR();  } ($xjN, my $pwN) = lxN($xjN, $_[0], $szN);  my $euN = swR();  print $euN;  $xjN .= $euN;  shL($xjN); 
my $fqN = vvC($pwN);  u2U(taC(q1B, 'pidfilepath'));  my $ubN = ''; $ubN .= "\nStatus file: ".taC(qjB, 'absstatusfilepath')  if taC(qjB,'statuson') ; $ubN .= "\nGroupStatus file: ".taC(qjB, 'absgroupstatusfilepath')  if taC(qjB, 'groupstatuson') ; $ubN .= "\nUptime file: ".taC(qjB, 'absuptimefilepath')  if taC(qjB,'uptimeon') ; $ubN .= "\nGroupUptime file: ".taC(qjB, 'absgroupuptimefilepath')  if taC(qjB, 'groupuptimeon') ; print "Log file: ".taC(q1B, 'abslogfilepath')."$ubN\n\n" ;  klU( taC(q1B, 'pidfilepath'), $jqN);  lvL(taC(q1B, 'logfilepath'));  siA( $yyN, q1B ) if $yyN;   test_autoload('Test autoload') if $ENV{DEVEL};  zfN($pwN, $fqN); } sub lxN { my ($xjN, $xzN, $szN) = @_; 
my $pwN = njN($xzN) ;  $xjN .= "\nFrom cfg file '$pwN'\n"; print $xjN unless $szN;  print cwM( 70) if ffB() ; return ($xjN, $pwN);  } sub njN { my $pwN = shift;  $pwN ||= '';  my $exN = quotemeta p1B; die seM.cwM(137, p1B )  if $pwN =~/[$exN]/; $pwN = ($pwN =~/^\\|^[a-z]:\/|^\//i ) ? $pwN  : nbB().xhB().$pwN ;  die seM.cwM(138, $pwN) unless -f $pwN;  yfB($pwN);  return $pwN ; } sub zfN {
my ($pwN, $fqN) = @_; my $ghN = vvB(); my $kwN = my $last_statusupdate = 0; my $kmN = taC(q1B, 'maxloops'); my $hjN = cwM( 101, $kmN) ; my $uvN = 0; my ($ubN, $bzN) = ('',''); my $teN = taC(q1B, 'pidfilepath') ;  my ($zzN, $xfN) = (0,0); my $dpN = 0;  my $ijN = 0; while (++$kwN <= $kmN ) {  shL("Start loop $kwN"); $uvN = time(); gdW(taC(q1B, 'watchdogport'));  $ijN = ynR( lgC() );   $fqN = vvC($pwN) ;  ($zzN, $xfN) = O_T::ppT($fqN, $kwN, $dpN); shL(vbM.dyM(2, $zzN) ) if $zzN; rfA();
siA(d1M.cwM( 102, ajB, 'alwayscheck', q1B)) if  (taC(q1B, ajB) and not $kwN%(int(10/emB)));  $bzN = ''; $bzN = dcR($kwN)  unless $kwN%10;   $ubN = ''; ($ubN, $dpN) = zvP( $fqN, $kwN, $bzN); hnN(cwM(103, $ubN, $xfN )); $ubN = ''; $ubN = fxL();  shL($ubN) if $ubN; hmP()  if (!(($kwN - 1 )%1000 ) and taC(qjB, 'uptimeon'));  jgC(); if (my $q3N = taC(q1B, $ijN)) {  if ((time() - $ghN) > int($q3N *3600)) {   $hjN = cwM( 104, $q3N); last; } } if ( -f $teN )  { my ($u1N, $nrN) = mhU($teN); 
chomp $u1N;  if ($nrN) { $hjN = aqM.cwM(57, $teN, $nrN) ; last;  } if ($u1N != $$) {   $hjN = cwM(181, $u1N); last; } } else { $hjN = cwM(105) ; last;  } msN($uvN);  }  my $tmp  = obM.$hjN;  shL("$tmp."); $hjN = obM.APP_N_HOST().cwM( 106, $hjN, $pwN ); i1A($hjN) ; 
}  my $yxN = sub { my $fsN = shift ; my $gjN = shift;      local $_; no strict 'refs';  my $hdN = '*'.$fsN.'::DATA';  no warnings;  seek $hdN,0,0 or return '';    use warnings;  my $feN = ''; my $yeN = 0;   while (<$hdN>) { $yeN = 1 if /^=pod/ ;   if ($yeN) { $yeN = 0 if /^=cut/;   next;  }   s/\r\n$/\n/;  /^__DATA__|^__END__/ and last;  
$feN .= $_ ; }     my $qnN = <$hdN>;  use strict;  my $vfN = evN($feN) ; $qnN =~s/[\r\n]//g;  if ($vfN ne $qnN) { print "$fsN\n$qnN\n$vfN\n"; if ( open DBGFH, ">tmp/$fsN".'.n' )  {  print DBGFH $feN ; close DBGFH;  } else { warn "111 $!" } my $tmp = txB;  if ($fsN =~/^$tmp\w/) { die seM . cwM(19-5, 3) ;  } } };  sub i8N {
if ($_[0] and $_[0] =~/^-makealltext/i) { my %o4N = bbB; foreach  (keys %o4N) { my @tmp = split;  ctN(a2N('!', @tmp), $_);  } } else { ckN( a2N(@_) ); } } sub ctN { my $ubN = shift; shift;  my $drN = shift;      my %o4N = (bbB());     my $jjN = jsB().xhB().mzB.xhB()."$o4N{$drN}.".prB;  qmU($jjN, $ubN);  } sub ztN {
ctN(a2N('!', '-ab'), '-ab' ) } sub faN {  map {$yxN->($_)} ( __PACKAGE__, 'O_P', 'O_D', 'Watchdog' ) ;  } sub ckN { my @hzN = split /\n/, shift; my $kiN = shift; my $vhN = 0; while (@hzN) { print shift @hzN, "\n"; if ($vhN++ > deB and $kiN) { print cwM( 107 ) ;  no warnings;  until ($_ = <STDIN>) {}  chomp; exit 0 if $_;   $vhN = 0; } }
} sub evN {return crG(shift);}  sub a2N { my $xjN = ''; $xjN = cwM( 108, $_[0] )  if $_[0];  my $kiN = 1;     if (my $feN = shift) { my $tbN = O_D::a3D(skB()); my $wgN = O_D::faD(skB()); my $dlN = ''; if ($feN =~/^!$/) {  $kiN = 0;             $feN = shift; $tbN = ''; $dlN = O_D::feD();  } $xjN = $yyN.O_D::a3D(skB()) . O_R::get_laR() . cwM(315, bhB()). O_D::auD() .
$wgN if $feN =~/^-ab/i; $xjN = pbN()  if $feN =~/^-ac/i; $xjN = $tbN . O_D::xoD() . $wgN if $feN =~/^-ad/i; $tbN = $yyN.$tbN;  $xjN = $tbN . O_D::xeD() . O_D::qpD() . O_D::mjD() . O_D::xzD('all') . O_D::bzD() . O_D::xnD(). O_D::dpD() . O_D::q3D() . O_D::drD() . O_D::xoD() .
$wgN if $feN =~/^-al/i; $xjN = ydN(@_)  if $feN =~/^-auth/i; $xjN = mnN()  if $feN =~/^-auto/i; $xjN = $tbN . O_D::mjD() . $wgN if $feN =~/^-b/i; $xjN = $tbN . O_D::xzD(@_) . $wgN if $feN =~/^-c/i; $xjN = wyN()  if $feN =~/^-dea/i; $xjN = $tbN . O_D::bzD() . $wgN if $feN =~/^-des/i;
$xjN = czN(1) if $feN =~/^-del/i;  $xjN = q2N(@_) if $feN =~/^-e/i; $xjN = $tbN . O_D::o4D(@_) . $wgN if $feN =~/^-f/i; $xjN = $tbN . O_D::amD() . O_D::xeD() . O_D::qpD() . O_D::mjD() . O_D::bzD() . $wgN if $feN =~/^-h|\?/i; $xjN = $tbN . O_D::xnD() . $wgN if $feN =~/^-k/i;
$xjN = $tbN . O_D::i8D() . $wgN if $feN =~/^-l/i; $xjN = $tbN . vdR(). $wgN if $feN =~/^-m/i; $xjN = $tbN . O_D::qpD() . $wgN if $feN =~/^-o/i; $xjN = $tbN . O_D::dpD() . $wgN if $feN =~/^-prot/i; $xjN = $tbN . $dlN . O_D::amD() . $wgN
if $feN =~/^-q/i; $xjN = $tbN . O_D::xeD() . $wgN if $feN =~/^-ru|^-sto/i; $xjN = $tbN . O_D::drD() . $wgN if $feN =~/^-slf/i; $xjN = $tbN . O_D::q3D() . $wgN if $feN =~/^-t/i; $xjN = $yyN .  O_D::qnD() . $wgN if $feN =~/^-uwi/i; $xjN = $yyN. O_D::vfD() . O_D::amD() .
O_D::xeD() . O_D::qpD() . O_D::mjD() . O_D::xzD('all') . O_D::bzD() . O_D::xnD(). O_D::dpD() . O_D::q3D() . O_D::drD() . O_D::xoD() . O_D::qnD() . $wgN if $feN =~/^-wh/i; $xjN = afC(@_) if $feN =~/^-nocfgkeyvalidation/i;  } else { $xjN = $yyN . O_D::a3D(skB()).cwM( 109, riB() ) } return ($xjN, $kiN); 
} use O_G 0.170424; sub czN { my $rvN = shift; $rvN ||= 1;  if (-f qbB.$rvN ) { unlink qbB.$rvN  or die seM.cwM( 44, $rvN, $!); } $yyN = ''; i8N('-makealltext') if $rvN == 2; } sub q2N {  local $_;  print cwM( 110);  my $wsN = ReadPassword();  if (my $nrN = znN($wsN)) { print cwM( 111, $nrN) ; return '';         }
print cwM(112);  my $cdN = ReadPassword();  unless ($wsN eq $cdN) { print cwM( 113);  return '';    } chomp $wsN;  my ($vwN, $nrN) = elU(1, $wsN); my $xdN = $nrN ? '' : erB; my $ubN = $nrN ? $nrN : cwM( 114, $vwN ); "$ubN$xdN\n"; } sub fgN { local $_ ; $_ = shift; chomp; s/^\s+//; s/\s+$//; my $lbN = quotemeta erB; my $jaN = $_ =~s/$lbN//;  my ($g1N, $nrN) = ($_,''); 
($g1N, $nrN) = elU(1, $_, 0) if $jaN;  return  wantarray ? ($g1N, $nrN) : "$g1N  $nrN" ;  } sub ydN { my $xcN = '';  dfU(2); if ( @_ ) { $xcN = cqN(@_); } else { $xcN = egN(); } $xcN;  } {  my $gzN = nmB().xhB().hhB; sub egN {  local $_;  print O_D::yeD(); print cwM( 115); 
my $dzN = bgU();   if (my $nrN = qoN($dzN)) { print cwM( 116, $nrN); return '';         } my $xjN = dbN($dzN); if ($xjN) { print $xjN; return ''; } print cwM( 117);  my $jpN = ReadPassword();  if (my $nrN = qoN($jpN, $dzN)) { print cwM( 116, $nrN); return '';         } print cwM( 118);  my $yjN = ReadPassword();  unless ($jpN eq $yjN) { print cwM( 119); 
return '';    } chomp $dzN;  chomp $jpN;  my ($qgN, $nrN) = elU(2, $dzN.':'.$jpN); my $xcN = ''; if ($nrN) { $xcN = "$nrN\n"; } else { if (open AFH, ">>$gzN" ) { print AFH "$qgN\n" ;  close AFH; $xcN = cwM( 120, $dzN );  } else {             $xcN = cwM( 121, 'appending', $! );   } } $xcN;
} sub dbN { my $dzN = shift;  my $xcN = '';  if ( open AFH, "<$gzN" ) { while (<AFH>) { chomp; next unless $_;  my ($tmp, $nrN) = elU(2, $_, 0); if ( $tmp =~/^$dzN/) { $xcN = cwM(184, $dzN) ;  last; } } }     else { $xcN = cwM(121, 'reading', $!); } close AFH; return $xcN;
} sub cqN { my $gwN = shift;  return cwM( 122) unless $gwN =~/d/i;  return cwM( 123, 1) unless -f $gzN;  my $llN = shift;  return cwM(42) unless ($llN and $llN =~/:/);  my ($qgN, $nrN) = elU(2, $llN); my $joN = quotemeta $qgN;  if (open DFH, $gzN) { my @rcN = <DFH>; close DFH;  my $buN = @rcN; return cwM( 123, 2) unless $buN;  @rcN = grep {$_ !~/$joN/} @rcN;   my $wfN = @rcN;  open DFH, ">$gzN" or die cwM( 124, 1, $!);  print DFH @rcN or die cwM( 125, $!);  close DFH; if ($buN == $wfN) {
return cwM( 125) } elsif ($buN > $wfN) { my $hxN = $wfN ? '' : cwM( 127); return cwM( 128, $hxN); } else { return cwM( 128) } } else {             return cwM( 130, 2, $!);  } return '';   } }  sub znN { my $ubN = shift;  return cwM( 131) unless ($ubN and $ubN !~/^0{1,}$/);
return cwM( 132) if $ubN =~/[\s:]/; return ''; } sub qoN { my ($sqN, $dzN) = @_;  return cwM( 132)  if $sqN =~/[\s:]/; my $upN = 8; return cwM(131, $upN)  if length $sqN < $upN ; my %gkN = (); my $tmp = $sqN; $gkN{$_} = 1  while ($_ = chop $tmp); my $alN = 5; return cwM(185, $alN)  if keys %gkN < $alN;  return cwM(186, $dzN)  if ($dzN and ($sqN =~/$dzN/)); return ''; } sub pbN { local $_;  my $ywN = o1R(dgB, 127+316) ; 
die seM . cwM(18, '.')   if $ywN;  print cwM(20); my ($dvN, $jpN) = chN(); return '' unless $dvN; chomp $dvN;  chomp $jpN;  my $kjN = oqN($dvN); return $kjN if $kjN;  my $fjN = $kjN eq '0' ? 0 : 1;  print cwM( 19);; my $xcN = ojR($dvN, $jpN, $fjN);  chomp $xcN;  print "$xcN\n"; return '';  } sub wyN { local $_;  return cwM(30, azR())  unless ( iaR() )[1] ; my $ywN = o1R(dgB, 127+316) ;  die seM . cwM(18, '.')  if $ywN; 
my @nzN = eoU(); return cwM( 22, @nzN) if @nzN ; print O_D::daD();  my ($dvN, $jpN) = chN(); return '' unless $dvN; chomp $dvN;  chomp $jpN;  my $kjN = oqN($dvN); return $kjN if $kjN;  print cwM(21); my $xcN = ojR($dvN, $jpN, -1);  chomp $xcN;  print "$xcN\n"; return '';  } sub oqN { my $mbN = shift; my $i1N = mtR() ;  return 0 unless $i1N;   my $siN = substr $i1N, 0, 6 ;
return cwM( 31, $siN)    if $mbN ne $i1N ;  return ''; } sub chN { print cwM( 15);  my $dvN = bgU();   if (my $nrN = wwN($dvN)) { print cwM( 16, $nrN); return '';         } print cwM( 26);  my $jpN = ReadPassword();  if (my $nrN = znN($jpN)) { print cwM( 16, $nrN); return '';         } print cwM( 27);  my $yjN = ReadPassword();  unless ($jpN eq $yjN) {
print cwM( 28);   return '';    } return ($dvN, $jpN );   } sub wwN { my $ubN = shift;  return cwM( 133)   unless $ubN =~/^[\w\-]{22}$/;  return ''; } sub stN { my $pzN = nmB().xhB().tvB ; my $wnN = ymB;  if ( open PRXYFH, "<$pzN" ) { my @tmp = <PRXYFH>;  close PRXYFH;  print cwM( 76, @tmp ); my $tmp = bgU(); chomp $tmp;   
return cwM( 83) unless $tmp; if ( $tmp eq 'd' ) {   unlink $pzN or die seM.cwM( 36, tvB, $! ); return cwM( 78) ; } } elsif ($! !~/$wnN/ ) {  print cwM( 33, tvB, $!) ;   } my @nzN = eoU(); return cwM( 77, @nzN) if @nzN ; print cwM( 72);  my $yiN = bgU();   if (my $nrN = fvN($yiN)) { return cwM( 73, $yiN, $nrN); } print cwM( 74);  my $xvN = bgU();   if (my $nrN = okN($xvN)) { return cwM( 75, $xvN, $nrN);
} my $nrN = qmU($pzN, $yiN,"\n", $xvN, "\n");  return  $nrN ? cwM( 84) : cwM( 85) ;   } sub fvN { my $sjN = shift;  return cwM(81)  unless $sjN;  return ( $sjN =~/^([[:alnum:]-]+\.?){2,5}$/  and length $sjN  < ysB ) ? ''   : cwM( 82)  ;   } sub okN { my $bmN = shift;  return cwM( 80)  unless $bmN; return ($bmN !~/\D/ and $bmN > 0 and $bmN < 65536 )  ? ''   : cwM( 79)  ;
} sub mnN { aeR(); my ($vrN, $mxN) = puR();  print cwM( 88, $vrN ? qlM : ulM , $mxN ? qlM : ulM  );  my $tmp = bgU(); chomp $tmp;  return ' ' unless $tmp; my $naN = nmB().xhB().caB ; my @tmp = ();   local $_;  foreach ( qw( upgrade downgrade) ) { print cwM( 86, $_);  my $xcN = bgU();   chomp $xcN; if ( $xcN eq 'd' ) { $xcN = ulM;  } elsif ( $xcN eq 'e') { $xcN = qlM;
} else {     return cwM( 87) ;  } push @tmp, "$_: $xcN\n";       } my $nrN = qmU($naN, @tmp );  ztN()  unless $nrN;  return  $nrN ? cwM( 134) : cwM( 135);   } sub msN { my ($nkN) = @_; my $whN = time(); my $ekN = $whN - $nkN; my $tmp = int(taC(q1B, 'minlooptime') * 60 + 10*rand) - $ekN;  shL(dyM(3, $tmp )); i2U($tmp); } {  my $zmN; 
sub hnN { my ($ubN) = @_; my $csN = taC(q1B, 'heartbeatperiod'); return unless $csN;  my $fiN = (localtime(time()))[2] ; defined $zmN or $zmN = $fiN;  my $mkN = $fiN%$csN; if ( $zmN != $fiN and not $mkN) { my $ncN = cwM(136, lkC(), APP_N_HOST() ); $ubN = cwM(309, yfB(), skB(), $$)."\n$ubN"; siA("$ncN\n$ubN", q1B); } $zmN = $fiN; } }  sub END{  return unless (voB() eq 'parent') ;  wbW() ;  xxU(taC(q1B, 'pidfilepath'), p1C(), @_);  }
sub s2N { O_A::ekA($_[0]) } 1;
__DATA__
0D+XhpS/HJhmK3giVMDBZA

